<template>
<div>
  <!-- mobile_start -->
  <div class="comm_main mobile_detail_ct">
    <!-- <confirm_bar v-if="account_name && has_confirm_permission" v-on:confirm="confirm" v-on:reject="reject"></confirm_bar> -->
    <div class="motion_item_ct">
      <div class="motion_item_content">
        <div class="md_title">
          {{ motion.title }}
        </div>
        <div class="md_des">
          {{ motion.content }}                   
        </div>
      </div>
      <div class="motion_item_status motion_item_status_detail">
        <div class="motion_res_title">{{ lang.data['公示结果'] }}</div>
        <div class="tab_pane">

          <div class="tab_header">
            <div class="tab_item" v-bind:class="{'tab_selected': motion.section == 0}">
              {{ lang.data['审批中'] }} <div class="tab_selected_arrow"></div>
            </div>
            <div class="tab_item" v-bind:class="{'tab_selected': motion.section == 1 && motion.approve_end_block_num > head_block_num}">
              {{ lang.data['公示中'] }} <div class="tab_selected_arrow"></div>
            </div>
            <div class="tab_item">
              {{ lang.data['执行中'] }} <div class="tab_selected_arrow"></div>
            </div>
            <div class="tab_item">
              {{ lang.data['已完成'] }} <div class="tab_selected_arrow"></div>
            </div>
          </div>
          <div class="tab_content" v-if="approves.data">

            <div class="tab_items">
              <div class="tab_item_title">
                {{ lang.data['同意'] }}
              </div>
              <div class="tab_item_tags">
                <span v-for="item in approves.data.approved">
                  {{ item }}、
                </span> 
                <span v-if="!approves.data.approved.length">
                  {{ lang.data['无同意'] }}
                </span>                         
              </div>

              <div class="tab_item_title">
                {{ lang.data['反对'] }}
              </div>

              <div class="tab_item_tags" >
                <span v-for="item in approves.data.unapproved">
                  {{ item }}、
                </span>    
                <span v-if="!approves.data.unapproved.length">
                  {{ lang.data['无反对'] }}
                </span>                    
              </div>

              <div class="tab_item_title">
                {{ lang.data['未表决'] }}
              </div>

              <div class="tab_item_tags">
                <span v-for="item in not_signed" >
                  {{ item }}、
                </span>  
                <span v-if="!not_signed.length">
                  {{ lang.data['无未表决'] }}
                </span>                    
              </div>
              <br/>
              <br/>
              <br/>
              <br/>
              <div class="cm_box">
                <div class="cm_box_title">
                  {{ lang.data['提币记录'] }}
                </div>
                
                <div class="cm_box_content" v-if="!take_coin_record.rows.length && !take_coin_record.on_load">
                  <div class="no_data">
                    {{ lang.data['当前无提币记录'] }}
                  </div>
                </div>
                
                <div class="cm_box_content" v-if="take_coin_record.rows.length && !take_coin_record.on_load">
                  
                  <div v-for="row in take_coin_record.rows" class="take_coin_record">
                    <div class="taker">
                      <div class="taker_title">{{ lang.data['提币人'] }}:</div>
                      <div class="taker_content">
                        {{row.receiver}}
                      </div>
                    </div>
                    <div class="taker">
                      <div class="taker_title">{{ lang.data['提币数量'] }}:</div>
                      <div class="taker_content">
                        {{row.quantity.split(' ')[0]  }} EOSC
                      </div>
                    </div>
                    <div class="taker">
                      <div class="taker_title">{{ lang.data['未表决'] }}:</div>
                      <div class="taker_content">
                        {{row.not_signed.join('、')}}
                      </div>
                    </div>
                    <div class="taker">
                      <div class="taker_title">{{ lang.data['已同意'] }}:</div>
                      <div class="taker_content">
                        {{row.approved.length ? row.approved.join('、') : lang.data['无']}}
                      </div>
                    </div>
                    <div class="taker">
                      <div class="taker_title">{{ lang.data['不同意'] }}:</div>
                      <div class="taker_content">
                        {{row.unapproved.length ? row.unapproved.join('、') : lang.data['无'] }}
                      </div>
                    </div>
                    <div class="taker">
                      <div class="taker_title">{{ lang.data['当前状态'] }}:</div>
                      <div class="taker_content" v-bind:class="{'orange_ft': !row.section, 'green_ft': row.section}">
                        {{row.section ? lang.data['已同意'] : lang.data['等待同意']}}
                      </div>
                    </div>
                  </div>
                </div>
              </div>


              <div class="toke_coin_form" v-if="account_name == motion.proposer && motion.section == 1 && motion.approve_end_block_num < head_block_num">
                
                <div class="form_item_ct">
                  <div class="form_item_tag">{{ lang.data['当前可提币最大数量'] }} <span class="max_quantitiy_tag">{{ motion.quantity.split(' ')[0] }}</span> EOSC</div>
                  <div class="form_item_ipt">
                    <input class="item_ipt" :placeholder="lang.data['提币数量']" v-model="take_coin_form.quantity" />
                  </div>
                  <div class="form_item_error">{{ take_coin_form.error }}</div>
                  <br/>
                  <div class="form_item_ipt">
                    <input class="item_ipt" :placeholder="lang.data['提币理由或备注']" v-model="take_coin_form.content" />
                  </div>

                </div>
                <div class="take_coin_btn" @click="takecoin">
                  <!-- <div class="load_circle"></div> -->
                  {{ lang.data['提币'] }}
                </div>

              </div>

            </div>

          </div>
        </div>
      </div>
      
    </div>
  </div>
  <!-- mobile_end -->
  <div class="comm_main motion_detail_pane" v-if="motion">
    <div class="motion_item_ct">
      <div class="motion_item_content">
        <div class="md_title">
          {{ motion.title }}
        </div>
        <div class="md_des" v-html="motion.content">
          <!-- {{ motion.content }}                         -->
        </div>
      </div>
      <div class="motion_item_status">
        <div class="motion_res_title">{{ lang.data['公示结果'] }}</div>
        <div class="tab_pane">

          <div class="tab_header">
            <div class="tab_item" v-bind:class="{'tab_selected': motion.section == 0}">
              {{ lang.data['审批中'] }} <div class="tab_selected_arrow"></div>
            </div>
            <div class="tab_item" v-bind:class="{'tab_selected': motion.section == 1 && motion.approve_end_block_num > head_block_num}">
              {{ lang.data['公示中'] }} <div class="tab_selected_arrow"></div>
            </div>
            <div class="tab_item"  v-bind:class="{'tab_selected': motion.section == 1 && motion.approve_end_block_num <= head_block_num}">
              {{ lang.data['已通过'] }}<div class="tab_selected_arrow"></div>
            </div>
            <!-- <div class="tab_item">
              {{ lang.data['已完成'] }} <div class="tab_selected_arrow"></div>
            </div> -->
          </div>

          <div class="tab_content" v-if="approves.data">

            <div class="tab_items">
              <div class="tab_item_title">
                {{ lang.data['同意'] }}
              </div>
              <div class="tab_item_tags">
                <span v-for="item in approved_res">
                  <comment_box :value="item"></comment_box>
                </span> 
                <span v-if="!approved_res.length">
                  {{ lang.data['无同意'] }}
                </span>                         
              </div>

              <div class="tab_item_title">
                {{ lang.data['反对'] }}
              </div>

              <div class="tab_item_tags" >
                <span v-for="item in unapproved_res">
                  <comment_box :value="item"></comment_box>
                </span>    
                <span v-if="!unapproved_res.length">
                  {{ lang.data['无反对'] }}
                </span>                    
              </div>

              <div class="tab_item_title">
                {{ lang.data['未表决'] }}
              </div>

              <div class="tab_item_tags">
                <span v-for="item in not_signed" >
                  {{ item }}、
                </span>  
                <span v-if="!not_signed.length">
                  {{ lang.data['无未表决'] }}
                </span>                    
              </div>
              <br/>
              <br/>
              <br/>
              <br/>
              <div class="cm_box">
                <div class="cm_box_title">{{ lang.data['提币记录'] }}</div>
                <div class="cm_box_content" v-if="!take_coin_record.rows.length && !take_coin_record.on_load">
                  <div class="no_data">{{ lang.data['当前无提币记录'] }}</div>
                </div>
                <div class="cm_box_content" v-if="take_coin_record.rows.length && !take_coin_record.on_load">
                  
                  <div v-for="row in take_coin_record.rows" class="take_coin_record">
                    <div class="taker">
                      <div class="taker_title">{{ lang.data['提币人'] }}:</div>
                      <div class="taker_content">
                        {{row.receiver}}
                      </div>
                    </div>
                    <div class="taker">
                      <div class="taker_title">{{ lang.data['提币数量'] }}:</div>
                      <div class="taker_content">
                        {{row.quantity.split(' ')[0]  }} EOSC
                      </div>
                    </div>
                    <div class="taker">
                      <div class="taker_title">{{ lang.data['未表决'] }}:</div>
                      <div class="taker_content">
                        {{row.not_signed.join('、')}}
                      </div>
                    </div>
                    <div class="taker">
                      <div class="taker_title">{{ lang.data['已同意'] }}:</div>
                      <div class="taker_content">
                        {{row.approved.length ? row.approved.join('、') : lang.data['无']}}
                      </div>
                    </div>
                    <div class="taker">
                      <div class="taker_title">{{ lang.data['不同意'] }}:</div>
                      <div class="taker_content">
                        {{row.unapproved.length ? row.unapproved.join('、') : lang.data['无'] }}
                      </div>
                    </div>
                    <div class="taker">
                      <div class="taker_title">{{ lang.data['当前状态'] }}:</div>
                      <div class="taker_content" v-bind:class="{'orange_ft': !row.section, 'green_ft': row.section}">
                        {{row.section ? lang.data['已同意'] : lang.data['等待同意']}}
                      </div>
                    </div>
                  </div>
                </div>
              </div>

              <div class="toke_coin_form" v-if="account_name == motion.proposer && motion.section == 1 && motion.approve_end_block_num < head_block_num">
                
                <div class="form_item_ct">
                  <div class="form_item_tag">{{ lang.data['当前可提币最大数量'] }} <span class="max_quantitiy_tag">{{ motion.quantity.split(' ')[0] }}</span> EOSC</div>
                  <div class="form_item_ipt">
                    <input class="item_ipt" :placeholder="lang.data['提币数量']" v-model="take_coin_form.quantity" />
                  </div>
                  <div class="form_item_error">{{ take_coin_form.error }}</div>
                  <br/>
                  <div class="form_item_ipt">
                    <input class="item_ipt" :placeholder="lang.data['提币理由或备注']" v-model="take_coin_form.content" />
                  </div>

                </div>
                <div class="take_coin_btn" @click="takecoin">
                  <!-- <div class="load_circle"></div> -->
                  {{ lang.data['提币'] }}
                </div>
              </div>

            </div>

          </div>
        </div>
      </div>
      
    </div>
    <confirm_bar v-if="account_name && has_confirm_permission" v-on:confirm="confirm" v-on:reject="reject"></confirm_bar>
  </div>
</div>
</template>
<script>
import { mapActions, mapState, mapMutations, mapGetters } from 'vuex';
import confirm_bar from './confirm_bar.vue'
import comment_box from '../components/base_comment_box.vue'
import {
  approve,
  unapprove,
  takecoin,
  query_takecoins,
  get_memo_by_motion
} from '../service'
import { lang } from '../lang'

export default {

  data () {
    return {
      take_coin_form: {
        quantity: '',
        content: '',
        error: '',
        on_load: false
      },
      take_coin_record: {
        rows: [],
        on_load: false
      },
      motion_approved_res: [],
      lang
    }
  },

  props: {
    approves: {
      type: Object,
      default () {
        return {};
      }
    },
    motion: {
      type: Object,
      default () {
        return {};
      }
    }
  },

  computed: {
    not_signed () {
      let res = [];
      if(!this.approves.data) return res;
      this.approves.data.requested.forEach(item => {
        if(!this.approves.data.approved.find(i => i == item) && !this.approves.data.unapproved.find(i => i == item)){
          res.push(item);
        }
      });
      return res;
    },
    head_block_num () {
      return this.account_info.head_block_num;
    },
    has_confirm_permission () {
      let approves = this.approves;
      if(!approves.data) return false;

      let all_actived_users = [].splice(0, 0, ...approves.data.approved);
      all_actived_users.splice(all_actived_users.length, 0, ...approves.data.unapproved);
      all_actived_users = new Set(all_actived_users);

      if(all_actived_users.has(this.account_name)) return false;
      if(new Set(approves.data.requested).has(this.account_name)) return true;
    },
    approved_res () {
      let res = [];
      let approves = this.approves;

      approves.data.approved.forEach(row => {
        let msg_item = this.motion_approved_res.find(i => i.approver == row);
        res.push({
          name: row,
          msg: msg_item ? msg_item.memo : ''
        })
      });

      return res;
    },
    unapproved_res () {
      let res = [];
      let approves = this.approves;

      approves.data.unapproved.forEach(row => {
        let msg_item = this.motion_approved_res.find(i => i.approver == row);
        res.push({
          name: row,
          msg: msg_item ? msg_item.memo : ''
        })
      });

      return res;
    },
    ...mapState(['account_info']),
    ...mapGetters(['account_name'])
  },

  watch: {
    account_name () {
      this.query_takecoins();
    },
    motion () {
      console.log(this.motion);
      console.log('this.motion');
    }
  },

  mounted () {
    console.log(this.motion);
    this.query_takecoins();
    this.get_memo_by_motion();
  },

  methods: {
    async get_memo_by_motion () {
      let data = await get_memo_by_motion(this.motion.id);
      this.motion_approved_res.splice(0, this.motion_approved_res.length, ...data.rows)
      console.log(data);
    },
    async confirm (memo) {
      let reult = await approve({approver: this.account_name, id: this.motion.id, memo}).catch(error => {
        alert(error);
        throw error;
      });
      this.$emit('reload_approves');
      this.get_memo_by_motion();
    },
    async reject (memo) {
      let reult = await unapprove({approver: this.account_name, id: this.motion.id, memo}).catch(error => {
        alert(error);
        throw error;
      });
      this.$emit('reload_approves');
      this.get_memo_by_motion();
    },
    async query_takecoins () {
      if(!this.motion.proposer) return ;
      this.take_coin_record.on_load = true;
      let data = await query_takecoins({scope: this.motion.proposer});
      data.rows.forEach(row => {
        row.not_signed = [];
        row.requested.forEach(i => {
          if(!row.approved.find(t => t==i) && !row.unapproved.find(t => t == i)){
            row.not_signed.push(i);
          }
        });
      });
      this.take_coin_record.on_load = false;
      this.take_coin_record.rows.splice(0, 0, ...data.rows);
    },
    async takecoin () {
      let quantity = parseFloat(this.take_coin_form.quantity);
      if(!quantity){
        this.take_coin_form.error = lang.data['填写数字'] || '填写数字';
        return ;
      }
      quantity = quantity.toFixed(4);
      quantity = quantity + ' EOS';
      let result = await takecoin({proposer: this.account_name, montion_id: this.motion.id, content: this.take_coin_form.content, quantity})
                   .catch(error => {
                    alert(error);
                   })
    }

  },

  components: {
    confirm_bar,
    comment_box
  }

}
</script>
<style lang="stylus" scoped="true">
.tab_item_tags
  display flex
  span
    margin-right 15px
</style>